/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Serdisp.xs. Do not edit this file, edit Serdisp.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Serdisp.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <serdisplib/serdisp.h>

#include <gd.h>
#include <gdfontt.h>
#include <gdfonts.h>
#include <gdfontmb.h>
#include <gdfontl.h>
#include <gdfontg.h>

#include "ppport.h"

typedef struct {

   serdisp_CONN_t	*	sdcd;
	serdisp_t		*	dd;
	int					invers;
	char				*	connection;
	char				*	display;
	char				*	options;

} Serdisp;

Serdisp*
new_serdisp(char *connection, char *display, char *options)
{
    Serdisp *serdisp		= malloc(sizeof(Serdisp));
    serdisp->connection		= savepv(connection);
    serdisp->display		= savepv(display);
    serdisp->options		= savepv(options);
    serdisp->invers		= 0;
    return serdisp;
}

int
init(Serdisp *serdisp)
{
	serdisp->sdcd = SDCONN_open(serdisp->connection);

	if (serdisp->sdcd == (serdisp_CONN_t*)0)
	{
		Perl_croak(aTHX_ "Error opening %s, additional info: %s", serdisp->connection, sd_geterrormsg());
	}

	/* opening and initialising the display */
	serdisp->dd = serdisp_init(serdisp->sdcd, serdisp->display, serdisp->options);

	if (!serdisp->dd)
	{
		SDCONN_close(serdisp->sdcd);
		Perl_croak(aTHX_ "Error opening display %s, additional info: %s", serdisp->display, sd_geterrormsg());
	}

	/* turning on backlight */
	serdisp_setoption(serdisp->dd, "BACKLIGHT", SD_OPTION_YES);

	/* clearing the display */
	serdisp_clear(serdisp->dd);

	return 1;
}

int
width(Serdisp *serdisp)
{
	return serdisp_getwidth(serdisp->dd);
}

int
height(Serdisp *serdisp)
{
	return serdisp_getheight(serdisp->dd);
}

#define min(a,b) ((a)<(b))?(a):(b)
#define GET_COLOR_VALUE(d)        ((d)->invers ? SD_COL_WHITE : SD_COL_BLACK)
#define GET_COLOR_VALUE_INVERS(d) ((d)->invers ? SD_COL_BLACK : SD_COL_WHITE)

int
copyGD(Serdisp *serdisp, gdImagePtr image)
{
	int max_x = min(gdImageSX(image), serdisp_getwidth(serdisp->dd));
	int max_y = min(gdImageSY(image), serdisp_getheight(serdisp->dd));

	int x,y;

	for (y = 0; y < max_y; y++)
	{
		for (x = 0; x < max_x; x++)
		{
			int color = gdImageGetPixel(image, x, y);

			//	set the pixel in the display if the color is non black
			int set_pixel_in_display =
					gdImageRed	(image, color)
				||	gdImageGreen(image, color)
				||	gdImageBlue	(image, color);

	      serdisp_setcolour(
	       	serdisp->dd,
	       	x, y,
	       	set_pixel_in_display
	       		?	GET_COLOR_VALUE(serdisp)
	 	      	:	GET_COLOR_VALUE_INVERS(serdisp)
	       );
		}
	}
	serdisp_update(serdisp->dd);
	
	return 1;
}

void
clear(Serdisp *serdisp)
{
	serdisp_clear(serdisp->dd);
}

int
update(Serdisp *serdisp)
{
	serdisp_update(serdisp->dd);
	
	return 1;
}

void
delete_display(Serdisp *serdisp) {

	/* shutdown display and release device*/
	serdisp_quit(serdisp->dd);
	free(serdisp);
}

void
set_option(Serdisp *serdisp, char *option, long value) {

	/* change option */
	serdisp_setoption(serdisp->dd,savepv(option),value);
}

long
get_option(Serdisp *serdisp, char *option) {

	/* get option */
	int temp = 0;
	return serdisp_getoption(serdisp->dd,savepv(option),&temp);
}

#line 163 "Serdisp.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 307 "Serdisp.c"

XS_EUPXS(XS_Device__Serdisp_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__Serdisp_new)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "CLASS, connection, display, options=\"\"");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	char *	connection = (char *)SvPV_nolen(ST(1))
;
	char *	display = (char *)SvPV_nolen(ST(2))
;
	char *	options;
	Serdisp *	RETVAL;

	if (items < 4)
	    options = "";
	else {
	    options = (char *)SvPV_nolen(ST(3))
;
	}
#line 162 "Serdisp.xs"
		RETVAL = new_serdisp(connection, display, options);
#line 333 "Serdisp.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
     sv_setref_pv(RETVALSV, CLASS, (void*) RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Device__Serdisp_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__Serdisp_init)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "serdisp");
    {
	Serdisp*     serdisp = (Serdisp *) SvIV((SV*)SvRV(ST(0)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = init(serdisp);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Device__Serdisp_width); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__Serdisp_width)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "serdisp");
    {
	Serdisp*     serdisp = (Serdisp *) SvIV((SV*)SvRV(ST(0)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = width(serdisp);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Device__Serdisp_height); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__Serdisp_height)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "serdisp");
    {
	Serdisp*     serdisp = (Serdisp *) SvIV((SV*)SvRV(ST(0)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = height(serdisp);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Device__Serdisp_copyGD); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__Serdisp_copyGD)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "serdisp, image");
    {
	Serdisp*     serdisp = (Serdisp *) SvIV((SV*)SvRV(ST(0)))
;
	gdImagePtr     image = (gdImagePtr) SvIV((SV*)SvRV(ST(1)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = copyGD(serdisp, image);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Device__Serdisp_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__Serdisp_update)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "serdisp");
    {
	Serdisp*     serdisp = (Serdisp *) SvIV((SV*)SvRV(ST(0)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = update(serdisp);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Device__Serdisp_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__Serdisp_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "serdisp");
    {
	Serdisp*     serdisp = (Serdisp *) SvIV((SV*)SvRV(ST(0)))
;

	clear(serdisp);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Device__Serdisp_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__Serdisp_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "serdisp");
    {
	Serdisp *     serdisp = (Serdisp *) SvIV((SV*)SvRV(ST(0)))
;
#line 195 "Serdisp.xs"
    delete_display(serdisp); /* deallocate that object */
#line 469 "Serdisp.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Device__Serdisp_set_option); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__Serdisp_set_option)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "serdisp, option, value");
    {
	Serdisp*     serdisp = (Serdisp *) SvIV((SV*)SvRV(ST(0)))
;
	char*	option = (char *)SvPV_nolen(ST(1))
;
	long	value = (long)SvIV(ST(2))
;

	set_option(serdisp, option, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Device__Serdisp_get_option); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__Serdisp_get_option)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "serdisp, option");
    {
	Serdisp*     serdisp = (Serdisp *) SvIV((SV*)SvRV(ST(0)))
;
	char*	option = (char *)SvPV_nolen(ST(1))
;
	long	RETVAL;
	dXSTARG;

	RETVAL = get_option(serdisp, option);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Device__Serdisp); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Device__Serdisp)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Device::Serdisp::new", XS_Device__Serdisp_new);
        newXS_deffile("Device::Serdisp::init", XS_Device__Serdisp_init);
        newXS_deffile("Device::Serdisp::width", XS_Device__Serdisp_width);
        newXS_deffile("Device::Serdisp::height", XS_Device__Serdisp_height);
        newXS_deffile("Device::Serdisp::copyGD", XS_Device__Serdisp_copyGD);
        newXS_deffile("Device::Serdisp::update", XS_Device__Serdisp_update);
        newXS_deffile("Device::Serdisp::clear", XS_Device__Serdisp_clear);
        newXS_deffile("Device::Serdisp::DESTROY", XS_Device__Serdisp_DESTROY);
        newXS_deffile("Device::Serdisp::set_option", XS_Device__Serdisp_set_option);
        newXS_deffile("Device::Serdisp::get_option", XS_Device__Serdisp_get_option);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

